#ifndef MEGADRIVE_H_
#define MEGADRIVE_H_

#include <stdint.h>

/* Macros for the joypad buttons */
#define DPAD_UP		0
#define DPAD_DOWN	1
#define DPAD_LEFT	2
#define DPAD_RIGHT	3
#define DPAD_A		12
#define DPAD_B		4
#define DPAD_C		5
#define DPAD_START	13

uint16_t dpad0;
uint16_t dpad0_prev;
uint16_t dpad0_presses;
uint16_t frame_buffer[2048];

int current_piece = 0x270;
int frame_delay = 50;
int frame_countdown;
int current_piece_x;
int current_piece_y;

int tetromino_shapes[8];
int statistics[16];

int last_spawned_piece_index;

int16_t rng_state[2];

int auto_repeat_countdown;


static inline dpad0_pressed(uint16_t key)
{
	return !(dpad0 & (1 << key));
}

int32_t rng_next(int32_t s);

static inline int rand(void)
{
	int32_t *s = (int32_t*)rng_state;
	*s = rng_next(*s);
	return ((*s) >> 24) & 0xff;
}


#endif	/* MEGADRIVE_H_ */
